//VAʐMCu for GR-SAKURA(RX63N) by I.N.
//             RXRSLIB 1.1

//CPU:ICLK=98MHz, PCLK=48MHz, sizeof(int)=4(32bit)

// 2014.11.26 ver.0.1 Jn
// 2014.12.01         (`l0-3,5-6),ERIg
// 2014.12.02 ver.1.0 ǉ(`l8,12)
// 2014.12.10 ver.1.1 TE=0TXDo̓nCCs[_XɂȂ_̏C

#ifndef RXRSLIB_H
#define RXRSLIB_H

#include <iodefine_gcc63n.h>

#ifdef __cplusplus
extern "C" {
#endif

//`l̍ő(0-3,5-6,8,12)
#define RXRS_COMNUM 13

//ftHg̑Mobt@TCY
#ifndef RXRS_RECVBUFFERSIZE0
	#define RXRS_RECVBUFFERSIZE0 32
#endif
#ifndef RXRS_SENDBUFFERSIZE0
	#define RXRS_SENDBUFFERSIZE0 32
#endif

#ifndef RXRS_RECVBUFFERSIZE1
	#define RXRS_RECVBUFFERSIZE1 32
#endif
#ifndef RXRS_SENDBUFFERSIZE1
	#define RXRS_SENDBUFFERSIZE1 32
#endif

#ifndef RXRS_RECVBUFFERSIZE2
	#define RXRS_RECVBUFFERSIZE2 32
#endif
#ifndef RXRS_SENDBUFFERSIZE2
	#define RXRS_SENDBUFFERSIZE2 32
#endif

#ifndef RXRS_RECVBUFFERSIZE3
	#define RXRS_RECVBUFFERSIZE3 32
#endif
#ifndef RXRS_SENDBUFFERSIZE3
	#define RXRS_SENDBUFFERSIZE3 32
#endif

#ifndef RXRS_RECVBUFFERSIZE5
	#define RXRS_RECVBUFFERSIZE5 32
#endif
#ifndef RXRS_SENDBUFFERSIZE5
	#define RXRS_SENDBUFFERSIZE5 32
#endif

#ifndef RXRS_RECVBUFFERSIZE6
	#define RXRS_RECVBUFFERSIZE6 32
#endif
#ifndef RXRS_SENDBUFFERSIZE6
	#define RXRS_SENDBUFFERSIZE6 32
#endif

#ifndef RXRS_RECVBUFFERSIZE8
	#define RXRS_RECVBUFFERSIZE8 32
#endif
#ifndef RXRS_SENDBUFFERSIZE8
	#define RXRS_SENDBUFFERSIZE8 32
#endif

#ifndef RXRS_RECVBUFFERSIZE12
	#define RXRS_RECVBUFFERSIZE12 32
#endif
#ifndef RXRS_SENDBUFFERSIZE12
	#define RXRS_SENDBUFFERSIZE12 32
#endif

// --- Mobt@ ---
unsigned char RXRS_rbuffer0[RXRS_RECVBUFFERSIZE0];
unsigned char RXRS_rbuffer1[RXRS_RECVBUFFERSIZE1];
unsigned char RXRS_rbuffer2[RXRS_RECVBUFFERSIZE2];
unsigned char RXRS_rbuffer3[RXRS_RECVBUFFERSIZE3];
unsigned char RXRS_rbuffer5[RXRS_RECVBUFFERSIZE5];
unsigned char RXRS_rbuffer6[RXRS_RECVBUFFERSIZE6];
unsigned char RXRS_rbuffer8[RXRS_RECVBUFFERSIZE8];
unsigned char RXRS_rbuffer12[RXRS_RECVBUFFERSIZE12];
volatile unsigned char *RXRS_rbuffer[RXRS_COMNUM]={RXRS_rbuffer0, RXRS_rbuffer1, RXRS_rbuffer2, RXRS_rbuffer3, NULL, RXRS_rbuffer5, RXRS_rbuffer6, NULL, RXRS_rbuffer8, NULL, NULL, NULL, RXRS_rbuffer12};
const int RXRS_rbuffersize[RXRS_COMNUM]={RXRS_RECVBUFFERSIZE0, RXRS_RECVBUFFERSIZE1, RXRS_RECVBUFFERSIZE2, RXRS_RECVBUFFERSIZE3, 0, RXRS_RECVBUFFERSIZE5, RXRS_RECVBUFFERSIZE6, 0, RXRS_RECVBUFFERSIZE8, 0, 0, 0, RXRS_RECVBUFFERSIZE12};
// RXRS_recv_wptrn ͎ɏރf[^ʒuw
volatile int RXRS_recv_wptr[RXRS_COMNUM];
// RXRS_recv_rptrn==-1̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int RXRS_recv_rptr[RXRS_COMNUM];

// --- Mobt@ ---
unsigned char RXRS_sbuffer0[RXRS_SENDBUFFERSIZE0];
unsigned char RXRS_sbuffer1[RXRS_SENDBUFFERSIZE1];
unsigned char RXRS_sbuffer2[RXRS_SENDBUFFERSIZE2];
unsigned char RXRS_sbuffer3[RXRS_SENDBUFFERSIZE3];
unsigned char RXRS_sbuffer5[RXRS_SENDBUFFERSIZE5];
unsigned char RXRS_sbuffer6[RXRS_SENDBUFFERSIZE6];
unsigned char RXRS_sbuffer8[RXRS_SENDBUFFERSIZE8];
unsigned char RXRS_sbuffer12[RXRS_SENDBUFFERSIZE12];
volatile unsigned char *RXRS_sbuffer[RXRS_COMNUM]={RXRS_sbuffer0, RXRS_sbuffer1, RXRS_sbuffer2, RXRS_sbuffer3, NULL, RXRS_sbuffer5, RXRS_sbuffer6, NULL, RXRS_sbuffer8, NULL, NULL, NULL, RXRS_sbuffer12};
const int RXRS_sbuffersize[RXRS_COMNUM]={RXRS_SENDBUFFERSIZE0, RXRS_SENDBUFFERSIZE1, RXRS_SENDBUFFERSIZE2, RXRS_SENDBUFFERSIZE3, 0, RXRS_SENDBUFFERSIZE5, RXRS_SENDBUFFERSIZE6, 0, RXRS_SENDBUFFERSIZE8, 0, 0, 0, RXRS_SENDBUFFERSIZE12};
// RXRS_send_wptrn ͎ɏރf[^ʒuw
volatile int RXRS_send_wptr[RXRS_COMNUM];
// RXRS_send_rptrn==-1̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int RXRS_send_rptr[RXRS_COMNUM];

char RXRS_openflag[RXRS_COMNUM];

//M荞݂̏(0:ҋ@ 1:M 2:TEI荞݂ֈڍs)
volatile int rxrs_rx_status[RXRS_COMNUM];

//O[v12(MG[ERIx)(114)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI_ERI(void)
{
	if(ICU.GRP[12].BIT.IS0){
		do{
			if(SCI0.SSR.BYTE & 0x38) SCI0.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI0.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS0);
	}

	if(ICU.GRP[12].BIT.IS1){
		do{
			if(SCI1.SSR.BYTE & 0x38) SCI1.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI1.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS1);
	}

	if(ICU.GRP[12].BIT.IS2){
		do{
			if(SCI2.SSR.BYTE & 0x38) SCI2.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI2.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS2);
	}

	if(ICU.GRP[12].BIT.IS3){
		do{
			if(SCI3.SSR.BYTE & 0x38) SCI3.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI3.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS3);
	}

	if(ICU.GRP[12].BIT.IS5){
		do{
			if(SCI5.SSR.BYTE & 0x38) SCI5.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI5.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS5);
	}

	if(ICU.GRP[12].BIT.IS6){
		do{
			if(SCI6.SSR.BYTE & 0x38) SCI6.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI6.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS6);
	}

	if(ICU.GRP[12].BIT.IS8){
		do{
			if(SCI8.SSR.BYTE & 0x38) SCI8.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI8.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS8);
	}

	if(ICU.GRP[12].BIT.IS12){
		do{
			if(SCI12.SSR.BYTE & 0x38) SCI12.SSR.BYTE &= ~0x38;	//G[(ORER,FER,PER)΃NA
		}while(SCI12.SSR.BYTE & 0x38);
		while(ICU.GRP[12].BIT.IS12);
	}
}

//M(RXI0:214)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI0_RXI0(void)
{
	unsigned char c;
	c= SCI0.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI0.SSR.BYTE & 0x38){
			SCI0.SSR.BYTE &= ~0x38;
		}
	}while(SCI0.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[0] == RXRS_recv_rptr[0]) return;		//buffer full
	RXRS_rbuffer[0][RXRS_recv_wptr[0]]= c;
	if (RXRS_recv_rptr[0]<0) RXRS_recv_rptr[0]= RXRS_recv_wptr[0];
	if (++RXRS_recv_wptr[0] == RXRS_rbuffersize[0]) RXRS_recv_wptr[0]= 0;
}

//M(TXI0:215)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI0_TXI0(void)
{
	int rp;
	rp= RXRS_send_rptr[0];

	SCI0.TDR= RXRS_sbuffer[0][rp++];
	while(SCI0.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[0]) rp= 0;
	if(rp==RXRS_send_wptr[0]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[0]= 2;
		SCI0.SCR.BIT.TEIE= 1;
		ICU.IER[0x1A].BIT.IEN7= 0;	//荞TXI0
		SCI0.SCR.BIT.TIE= 0;
		while(SCI0.SCR.BIT.TIE);
	}
	RXRS_send_rptr[0]= rp;
}

//MI(TEI0:216)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI0_TEI0(void)
{
#ifdef SCI0_RXDTXD_P33P32
	PORT3.PMR.BIT.B2= 0;	//P32:ėpI/O
#else
	PORT2.PMR.BIT.B0= 0;	//P20:ėpI/O
#endif
	SCI0.SCR.BIT.TE= 0;
	SCI0.SCR.BIT.TEIE= 0;
	while(SCI0.SCR.BIT.TEIE);
	rxrs_rx_status[0]= 0;
}

//M(RXI1:217)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI1_RXI1(void)
{
	unsigned char c;
	c= SCI1.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI1.SSR.BYTE & 0x38){
			SCI1.SSR.BYTE &= ~0x38;
		}
	}while(SCI1.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[1] == RXRS_recv_rptr[1]) return;		//buffer full
	RXRS_rbuffer[1][RXRS_recv_wptr[1]]= c;
	if (RXRS_recv_rptr[1]<0) RXRS_recv_rptr[1]= RXRS_recv_wptr[1];
	if (++RXRS_recv_wptr[1] == RXRS_rbuffersize[1]) RXRS_recv_wptr[1]= 0;
}

//M(TXI1:218)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI1_TXI1(void)
{
	int rp;
	rp= RXRS_send_rptr[1];

	SCI1.TDR= RXRS_sbuffer[1][rp++];
	while(SCI1.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[1]) rp= 0;
	if(rp==RXRS_send_wptr[1]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[1]= 2;
		SCI1.SCR.BIT.TEIE= 1;
		ICU.IER[0x1B].BIT.IEN2= 0;	//荞TXI1
		SCI1.SCR.BIT.TIE= 0;
		while(SCI1.SCR.BIT.TIE);
	}
	RXRS_send_rptr[1]= rp;
}

//MI(TEI1:219)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI1_TEI1(void)
{
	PORT2.PMR.BIT.B6= 0;	//P26:ėpI/O
	SCI1.SCR.BIT.TE= 0;
	SCI1.SCR.BIT.TEIE= 0;
	while(SCI1.SCR.BIT.TEIE);
	rxrs_rx_status[1]= 0;
}

//M(RXI2:220)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI2_RXI2(void)
{
	unsigned char c;
	c= SCI2.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI2.SSR.BYTE & 0x38){
			SCI2.SSR.BYTE &= ~0x38;
		}
	}while(SCI2.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[2] == RXRS_recv_rptr[2]) return;		//buffer full
	RXRS_rbuffer[2][RXRS_recv_wptr[2]]= c;
	if (RXRS_recv_rptr[2]<0) RXRS_recv_rptr[2]= RXRS_recv_wptr[2];
	if (++RXRS_recv_wptr[2] == RXRS_rbuffersize[2]) RXRS_recv_wptr[2]= 0;
}

//M(TXI2:221)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI2_TXI2(void)
{
	int rp;
	rp= RXRS_send_rptr[2];

	SCI2.TDR= RXRS_sbuffer[2][rp++];
	while(SCI2.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[2]) rp= 0;
	if(rp==RXRS_send_wptr[2]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[2]= 2;
		SCI2.SCR.BIT.TEIE= 1;
		ICU.IER[0x1B].BIT.IEN5= 0;	//荞TXI2
		SCI2.SCR.BIT.TIE= 0;
		while(SCI2.SCR.BIT.TIE);
	}
	RXRS_send_rptr[2]= rp;
}

//MI(TEI2:222)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI2_TEI2(void)
{
#ifdef SCI2_RXDTXD_P52P50
	PORT5.PMR.BIT.B0= 0;	//P50:ėpI/O
#else
	PORT1.PMR.BIT.B3= 0;	//P13:ėpI/O
#endif
	SCI2.SCR.BIT.TE= 0;
	SCI2.SCR.BIT.TEIE= 0;
	while(SCI2.SCR.BIT.TEIE);
	rxrs_rx_status[2]= 0;
}

//M(RXI3:223)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI3_RXI3(void)
{
	unsigned char c;
	c= SCI3.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI3.SSR.BYTE & 0x38){
			SCI3.SSR.BYTE &= ~0x38;
		}
	}while(SCI3.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[3] == RXRS_recv_rptr[3]) return;		//buffer full
	RXRS_rbuffer[3][RXRS_recv_wptr[3]]= c;
	if (RXRS_recv_rptr[3]<0) RXRS_recv_rptr[3]= RXRS_recv_wptr[3];
	if (++RXRS_recv_wptr[3] == RXRS_rbuffersize[3]) RXRS_recv_wptr[3]= 0;
}

//M(TXI3:224)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI3_TXI3(void)
{
	int rp;
	rp= RXRS_send_rptr[3];

	SCI3.TDR= RXRS_sbuffer[3][rp++];
	while(SCI3.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[3]) rp= 0;
	if(rp==RXRS_send_wptr[3]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[3]= 2;
		SCI3.SCR.BIT.TEIE= 1;
		ICU.IER[0x1C].BIT.IEN0= 0;	//荞TXI3
		SCI3.SCR.BIT.TIE= 0;
		while(SCI3.SCR.BIT.TIE);
	}
	RXRS_send_rptr[3]= rp;
}

//MI(TEI3:225)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI3_TEI3(void)
{
	PORT2.PMR.BIT.B3= 0;	//P23:ėpI/O
	SCI3.SCR.BIT.TE= 0;
	SCI3.SCR.BIT.TEIE= 0;
	while(SCI3.SCR.BIT.TEIE);
	rxrs_rx_status[3]= 0;
}

//M(RXI5:229)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI5_RXI5(void)
{
	unsigned char c;
	c= SCI5.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI5.SSR.BYTE & 0x38){
			SCI5.SSR.BYTE &= ~0x38;
		}
	}while(SCI5.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[5] == RXRS_recv_rptr[5]) return;		//buffer full
	RXRS_rbuffer[5][RXRS_recv_wptr[5]]= c;
	if (RXRS_recv_rptr[5]<0) RXRS_recv_rptr[5]= RXRS_recv_wptr[5];
	if (++RXRS_recv_wptr[5] == RXRS_rbuffersize[5]) RXRS_recv_wptr[5]= 0;
}

//M(TXI5:230)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI5_TXI5(void)
{
	int rp;
	rp= RXRS_send_rptr[5];

	SCI5.TDR= RXRS_sbuffer[5][rp++];
	while(SCI5.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[5]) rp= 0;
	if(rp==RXRS_send_wptr[5]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[5]= 2;
		SCI5.SCR.BIT.TEIE= 1;
		ICU.IER[0x1C].BIT.IEN6= 0;	//荞TXI5
		SCI5.SCR.BIT.TIE= 0;
		while(SCI5.SCR.BIT.TIE);
	}
	RXRS_send_rptr[5]= rp;
}

//MI(TEI5:231)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI5_TEI5(void)
{
	PORTC.PMR.BIT.B3= 0;	//PC3:ėpI/O
	SCI5.SCR.BIT.TE= 0;
	SCI5.SCR.BIT.TEIE= 0;
	while(SCI5.SCR.BIT.TEIE);
	rxrs_rx_status[5]= 0;
}

//M(RXI6:232)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI6_RXI6(void)
{
	unsigned char c;
	c= SCI6.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI6.SSR.BYTE & 0x38){
			SCI6.SSR.BYTE &= ~0x38;
		}
	}while(SCI6.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[6] == RXRS_recv_rptr[6]) return;		//buffer full
	RXRS_rbuffer[6][RXRS_recv_wptr[6]]= c;
	if (RXRS_recv_rptr[6]<0) RXRS_recv_rptr[6]= RXRS_recv_wptr[6];
	if (++RXRS_recv_wptr[6] == RXRS_rbuffersize[6]) RXRS_recv_wptr[6]= 0;
}

//M(TXI6:233)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI6_TXI6(void)
{
	int rp;
	rp= RXRS_send_rptr[6];

	SCI6.TDR= RXRS_sbuffer[6][rp++];
	while(SCI6.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[6]) rp= 0;
	if(rp==RXRS_send_wptr[6]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[6]= 2;
		SCI6.SCR.BIT.TEIE= 1;
		ICU.IER[0x1D].BIT.IEN1= 0;	//荞TXI6
		SCI6.SCR.BIT.TIE= 0;
		while(SCI6.SCR.BIT.TIE);
	}
	RXRS_send_rptr[6]= rp;
}

//MI(TEI6:234)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI6_TEI6(void)
{
	PORT3.PMR.BIT.B2= 0;	//P32:ėpI/O
	SCI6.SCR.BIT.TE= 0;
	SCI6.SCR.BIT.TEIE= 0;
	while(SCI6.SCR.BIT.TEIE);
	rxrs_rx_status[6]= 0;
}

//M(RXI8:238)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI8_RXI8(void)
{
	unsigned char c;
	c= SCI8.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI8.SSR.BYTE & 0x38){
			SCI8.SSR.BYTE &= ~0x38;
		}
	}while(SCI8.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[8] == RXRS_recv_rptr[8]) return;		//buffer full
	RXRS_rbuffer[8][RXRS_recv_wptr[8]]= c;
	if (RXRS_recv_rptr[8]<0) RXRS_recv_rptr[8]= RXRS_recv_wptr[8];
	if (++RXRS_recv_wptr[8] == RXRS_rbuffersize[8]) RXRS_recv_wptr[8]= 0;
}

//M(TXI8:239)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI8_TXI8(void)
{
	int rp;
	rp= RXRS_send_rptr[8];

	SCI8.TDR= RXRS_sbuffer[8][rp++];
	while(SCI8.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[8]) rp= 0;
	if(rp==RXRS_send_wptr[8]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[8]= 2;
		SCI8.SCR.BIT.TEIE= 1;
		ICU.IER[0x1D].BIT.IEN7= 0;	//荞TXI8
		SCI8.SCR.BIT.TIE= 0;
		while(SCI8.SCR.BIT.TIE);
	}
	RXRS_send_rptr[8]= rp;
}

//MI(TEI8:240)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI8_TEI8(void)
{
	PORTC.PMR.BIT.B7= 0;	//PC7:ėpI/O
	SCI8.SCR.BIT.TE= 0;
	SCI8.SCR.BIT.TEIE= 0;
	while(SCI8.SCR.BIT.TEIE);
	rxrs_rx_status[8]= 0;
}

//M(RXI12:250)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI12_RXI12(void)
{
	unsigned char c;
	c= SCI12.RDR;	//PoCgǂݍ
	
	//G[(ORER,FER,PER)΃NA
	do{
		if(SCI12.SSR.BYTE & 0x38){
			SCI12.SSR.BYTE &= ~0x38;
		}
	}while(SCI12.SSR.BYTE & 0x38);

	if (RXRS_recv_wptr[12] == RXRS_recv_rptr[12]) return;		//buffer full
	RXRS_rbuffer[12][RXRS_recv_wptr[12]]= c;
	if (RXRS_recv_rptr[12]<0) RXRS_recv_rptr[12]= RXRS_recv_wptr[12];
	if (++RXRS_recv_wptr[12] == RXRS_rbuffersize[12]) RXRS_recv_wptr[12]= 0;
}

//M(TXI12:251)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI12_TXI12(void)
{
	int rp;
	rp= RXRS_send_rptr[12];

	SCI12.TDR= RXRS_sbuffer[12][rp++];
	while(SCI12.SSR.BIT.TEND);	//M(TEND=0)mFĎ֐i

	if(rp==RXRS_sbuffersize[12]) rp= 0;
	if(rp==RXRS_send_wptr[12]){
		rp= -1;					//ŏIf[^
		rxrs_rx_status[12]= 2;
		SCI12.SCR.BIT.TEIE= 1;
		ICU.IER[0x1F].BIT.IEN3= 0;	//荞TXI12
		SCI12.SCR.BIT.TIE= 0;
		while(SCI12.SCR.BIT.TIE);
	}
	RXRS_send_rptr[12]= rp;
}

//MI(TEI12:252)ŌĂяo
void __attribute__ ((interrupt)) RXRS_SCI12_TEI12(void)
{
	PORTE.PMR.BIT.B1= 0;	//PE1:ėpI/O
	SCI12.SCR.BIT.TE= 0;
	SCI12.SCR.BIT.TEIE= 0;
	while(SCI12.SCR.BIT.TEIE);
	rxrs_rx_status[12]= 0;
}

//--------------------------------------------------------------------------------
// |[g̃I[v RXRS_Open()
//--------------------------------------------------------------------------------
// ncom : `lԍ(0-3,5-6,8,12)
// brr  : {[[gw  vZ 48M/(16*(brr+1)) [bps]
//  brrlƃ{[[g
//          0 ->3000000.0 [bps]
//          1 ->1500000.0 [bps]
//          2 ->1000000.0 [bps]
//          3 -> 750000.0 [bps]
//          4 -> 600000.0 [bps]
//          5 -> 500000.0 [bps]
//          6 -> 428571.4 [bps]
//          7 -> 375000.0 [bps]
//          8 -> 333333.3 [bps]
//          9 -> 300000.0 [bps]
//         10 -> 272727.3 [bps]
//         11 -> 250000.0 [bps]
//         12 -> 230769.2 [bps]
//         25 -> 115384.6 [bps]
//         51 ->  57692.3 [bps]
//         77 ->  38461.5 [bps]
//        155 ->  19230.8 [bps]
//--------------------------------------------------------------------------------
// IvVFrxrslib.h̃CN[hOɈȉ`ƒʐMdlύXł
//             ȗ́CpeBȂCXgbvrbgPCf[^W
//             (`lx:0-3,5-6,8,12)
//   #define SCIx_PARITY_ODD
//   #define SCIx_PARITY_EVEN
//   #define SCIx_STOP_2
//   #define SCIx_DATA_7
//    Mobt@TCY(ftHg:32)(`lx:0-3,5-6,8,12)(n:TCY[oCg])
//   #define RXRS_RECVBUFFERSIZEx n 
//    Mobt@TCY(ftHg:32)(`lx:0-3,5-6,8,12)(n:TCY[oCg])
//   #define RXRS_SENDBUFFERSIZEx n
//--------------------------------------------------------------------------------
// gp|[g̃ftHg
// SCI0:  |[gP21(IO0)  =RXD, P20(IO1)  =TXD
// SCI1:  |[gP30(CN6-6)=RXD, P26(CN6-3)=TXD
// SCI2:  |[gP12(IO30) =RXD, P13(IO31) =TXD
// SCI3:  |[gP25(IO5)  =RXD, P23(IO3)  =TXD
// SCI5:  |[gPC2(IO8)  =RXD, PC3(IO9)  =TXD
// SCI6:  |[gP33(IO7)  =RXD, P32(IO6)  =TXD
// SCI8:  |[gPC6(IO11) =RXD, PC7(IO12) =TXD
// SCI12: |[gPE2(IO46) =RXD, PE1(IO45) =TXD
// |[gP33(IO7)=RXD, P32(IO6)=TXDgɂ͎sCN[hOɒ`
//   #define SCI0_RXDTXD_P33P32
// |[gP52(IO26)=RXD, P50(IO24)=TXDgɂ͎sCN[hOɒ`
//   #define SCI2_RXDTXD_P52P50
//--------------------------------------------------------------------------------
int RXRS_Open(int ncom, int brr)
{
	if(RXRS_openflag[ncom]) return 1;	//łɃI[v̂Ƃ

	//Mobt@̃|C^
	RXRS_recv_wptr[ncom]=0;
	RXRS_recv_rptr[ncom]=-1;
	RXRS_send_wptr[ncom]=0;
	RXRS_send_rptr[ncom]=-1;

	switch(ncom){
		// ----- SCI0 -----
		case 0:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB31= 0;	//SCI0W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI0.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
		#ifdef SCI0_RXDTXD_P33P32
			PORT3.PODR.BIT.B2= 1;			//P32:1o
			PORT3.PDR.BIT.B2= 1;			//P32:-o
			PORT3.PMR.BIT.B2= 0;			//P32:ėpI/O
			PORT3.PMR.BIT.B3= 0;			//P33:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P32PFS.BIT.PSEL= 0x0b;		//|[gP32:TXD0
			MPC.P33PFS.BIT.PSEL= 0x0b;		//|[gP33:RXD0
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORT3.PMR.BIT.B2= 1;			//P32:Ӌ@\ɐݒ(ł͂Ȃ)
			PORT3.PMR.BIT.B3= 1;			//P33:Ӌ@\ɐݒ
		#else
			PORT2.PODR.BIT.B0= 1;			//P20:1o
			PORT2.PDR.BIT.B0= 1;			//P20:-o
			PORT2.PMR.BIT.B0= 0;			//P20:ėpI/O
			PORT2.PMR.BIT.B1= 0;			//P21:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P20PFS.BIT.PSEL= 0x0a;		//|[gP20:TXD0
			MPC.P21PFS.BIT.PSEL= 0x0a;		//|[gP21:RXD0
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORT2.PMR.BIT.B0= 1;			//P20:Ӌ@\ɐݒ(ł͂Ȃ)
			PORT2.PMR.BIT.B1= 1;			//P21:Ӌ@\ɐݒ
		#endif

			SCI0.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI0.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI0_PARITY_EVEN
					SCI0.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI0_PARITY_ODD
					SCI0.SMR.BIT.PE= 1;		//peBL
					SCI0.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI0_STOP_2
					SCI0.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI0_DATA_7
					SCI0.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI0.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI0.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI0.BRR= brr;			//{[[g(BRR)w

			SCI0.SCR.BIT.RE= 1;		//M
			//SCI0.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[214].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1A].BIT.IEN6= 1;	//荞RXI0[xN^214]
			//ICU.IER[0x1A].BIT.IEN7= 1;	//荞TXI0[xN^215]
			ICU.IER[0x1B].BIT.IEN0= 1;	//荞TEI0[xN^216]

			ICU.IR[214].BIT.IR= 0;
			ICU.IR[215].BIT.IR= 0;
			ICU.IR[216].BIT.IR= 0;

			SCI0.SCR.BIT.RIE= 1;		//M݋
			//SCI0.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN0= 1;		//O[v12(ERI0)荞݋
			break;

		// ----- SCI1 -----
		case 1:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB30= 0;	//SCI1W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI1.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
			PORT2.PODR.BIT.B6= 1;			//P26:1o
			PORT2.PDR.BIT.B6= 1;			//P26:-o
			PORT2.PMR.BIT.B6= 0;			//P26:ėpI/O
			PORT3.PMR.BIT.B0= 0;			//P30:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P26PFS.BIT.PSEL= 0x0a;		//|[gP26:TXD1
			MPC.P30PFS.BIT.PSEL= 0x0a;		//|[gP30:RXD1
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORT2.PMR.BIT.B6= 1;			//P26:Ӌ@\ɐݒ(ł͂Ȃ)
			PORT3.PMR.BIT.B0= 1;			//P30:Ӌ@\ɐݒ

			SCI1.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI1.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI1_PARITY_EVEN
					SCI1.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI1_PARITY_ODD
					SCI1.SMR.BIT.PE= 1;		//peBL
					SCI1.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI1_STOP_2
					SCI1.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI1_DATA_7
					SCI1.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI1.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI1.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI1.BRR= brr;			//{[[g(BRR)w

			SCI1.SCR.BIT.RE= 1;		//M
			//SCI1.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[217].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN1= 1;	//荞RXI1[xN^217]
			//ICU.IER[0x1B].BIT.IEN2= 1;	//荞TXI1[xN^218]
			ICU.IER[0x1B].BIT.IEN3= 1;	//荞TEI1[xN^219]

			ICU.IR[217].BIT.IR= 0;
			ICU.IR[218].BIT.IR= 0;
			ICU.IR[219].BIT.IR= 0;

			SCI1.SCR.BIT.RIE= 1;		//M݋
			//SCI1.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN1= 1;		//O[v12(ERI1)荞݋
			break;

		// ----- SCI2 -----
		case 2:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB29= 0;	//SCI2W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI2.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
		#ifdef SCI2_RXDTXD_P52P50
			PORT5.PODR.BIT.B0= 1;			//P50:1o
			PORT5.PDR.BIT.B0= 1;			//P50:-o
			PORT5.PMR.BIT.B0= 0;			//P50:ėpI/O
			PORT5.PMR.BIT.B2= 0;			//P52:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P50PFS.BIT.PSEL= 0x0a;		//|[gP50:TXD2
			MPC.P52PFS.BIT.PSEL= 0x0a;		//|[gP52:RXD2
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORT5.PMR.BIT.B0= 1;			//P50:Ӌ@\ɐݒ(ł͂Ȃ)
			PORT5.PMR.BIT.B2= 1;			//P52:Ӌ@\ɐݒ
		#else
			PORT1.PMR.BIT.B2= 0;			//P12:ėpI/O
			PORT1.PODR.BIT.B3= 1;			//P13:1o
			PORT1.PDR.BIT.B3= 1;			//P13:-o
			PORT1.PMR.BIT.B3= 0;			//P13:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P13PFS.BIT.PSEL= 0x0a;		//|[gP13:TXD2
			MPC.P12PFS.BIT.PSEL= 0x0a;		//|[gP12:RXD2
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT1.PMR.BIT.B2= 1;			//P12:Ӌ@\ɐݒ
			//PORT1.PMR.BIT.B3= 1;			//P13:Ӌ@\ɐݒ(ł͂Ȃ)
		#endif

			SCI2.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI2.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI2_PARITY_EVEN
					SCI2.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI2_PARITY_ODD
					SCI2.SMR.BIT.PE= 1;		//peBL
					SCI2.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI2_STOP_2
					SCI2.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI2_DATA_7
					SCI2.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI2.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI2.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI2.BRR= brr;			//{[[g(BRR)w

			SCI2.SCR.BIT.RE= 1;		//M
			//SCI2.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[220].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN4= 1;	//荞RXI2[xN^220]
			//ICU.IER[0x1B].BIT.IEN5= 1;	//荞TXI2[xN^221]
			ICU.IER[0x1B].BIT.IEN6= 1;	//荞TEI2[xN^222]

			ICU.IR[220].BIT.IR= 0;
			ICU.IR[221].BIT.IR= 0;
			ICU.IR[222].BIT.IR= 0;

			SCI2.SCR.BIT.RIE= 1;		//M݋
			//SCI2.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN2= 1;		//O[v12(ERI2)荞݋
			break;

		// ----- SCI3 -----
		case 3:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB28= 0;	//SCI3W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI3.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
			PORT2.PODR.BIT.B3= 1;			//P23:1o
			PORT2.PDR.BIT.B3= 1;			//P23:-o
			PORT2.PMR.BIT.B3= 0;			//P23:ėpI/O
			PORT2.PMR.BIT.B5= 0;			//P25:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P23PFS.BIT.PSEL= 0x0a;		//|[gP23:TXD3
			MPC.P25PFS.BIT.PSEL= 0x0a;		//|[gP25:RXD3
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORT2.PMR.BIT.B3= 1;			//P23:Ӌ@\ɐݒ(ł͂Ȃ)
			PORT2.PMR.BIT.B5= 1;			//P25:Ӌ@\ɐݒ

			SCI3.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI3.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI3_PARITY_EVEN
					SCI3.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI3_PARITY_ODD
					SCI3.SMR.BIT.PE= 1;		//peBL
					SCI3.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI3_STOP_2
					SCI3.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI3_DATA_7
					SCI3.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI3.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI3.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI3.BRR= brr;			//{[[g(BRR)w

			SCI3.SCR.BIT.RE= 1;		//M
			//SCI3.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[223].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN7= 1;	//荞RXI3[xN^223]
			//ICU.IER[0x1C].BIT.IEN0= 1;	//荞TXI3[xN^224]
			ICU.IER[0x1C].BIT.IEN1= 1;	//荞TEI3[xN^225]

			ICU.IR[223].BIT.IR= 0;
			ICU.IR[224].BIT.IR= 0;
			ICU.IR[225].BIT.IR= 0;

			SCI3.SCR.BIT.RIE= 1;		//M݋
			//SCI3.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN3= 1;		//O[v12(ERI3)荞݋
			break;

		// ----- SCI5 -----
		case 5:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB26= 0;	//SCI5W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI5.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
			PORTC.PMR.BIT.B2= 0;			//PC2:ėpI/O
			PORTC.PODR.BIT.B3= 1;			//PC3:1o
			PORTC.PDR.BIT.B3= 1;			//PC3:-o
			PORTC.PMR.BIT.B3= 0;			//PC3:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.PC3PFS.BIT.PSEL= 0x0a;		//|[gPC3:TXD5
			MPC.PC2PFS.BIT.PSEL= 0x0a;		//|[gPC2:RXD5
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORTC.PMR.BIT.B2= 1;			//PC2:Ӌ@\ɐݒ
			//PORTC.PMR.BIT.B3= 1;			//PC3:Ӌ@\ɐݒ(ł͂Ȃ)

			SCI5.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI5.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI5_PARITY_EVEN
					SCI5.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI5_PARITY_ODD
					SCI5.SMR.BIT.PE= 1;		//peBL
					SCI5.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI5_STOP_2
					SCI5.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI5_DATA_7
					SCI5.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI5.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI5.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI5.BRR= brr;			//{[[g(BRR)w

			SCI5.SCR.BIT.RE= 1;		//M
			//SCI5.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[229].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1C].BIT.IEN5= 1;	//荞RXI5[xN^229]
			//ICU.IER[0x1C].BIT.IEN6= 1;	//荞TXI5[xN^230]
			ICU.IER[0x1C].BIT.IEN7= 1;	//荞TEI5[xN^231]

			ICU.IR[229].BIT.IR= 0;
			ICU.IR[230].BIT.IR= 0;
			ICU.IR[231].BIT.IR= 0;

			SCI5.SCR.BIT.RIE= 1;		//M݋
			//SCI5.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN5= 1;		//O[v12(ERI5)荞݋
			break;

			// ----- SCI6 -----
		case 6:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB25= 0;	//SCI6W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI6.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
			PORT3.PODR.BIT.B2= 1;			//P32:1o
			PORT3.PDR.BIT.B2= 1;			//P32:-o
			PORT3.PMR.BIT.B2= 0;			//P32:ėpI/O
			PORT3.PMR.BIT.B3= 0;			//P33:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P32PFS.BIT.PSEL= 0x0a;		//|[gP32:TXD6
			MPC.P33PFS.BIT.PSEL= 0x0a;		//|[gP33:RXD6
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORT3.PMR.BIT.B2= 1;			//P32:Ӌ@\ɐݒ(ł͂Ȃ)
			PORT3.PMR.BIT.B3= 1;			//P33:Ӌ@\ɐݒ

			SCI6.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI6.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI6_PARITY_EVEN
					SCI6.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI6_PARITY_ODD
					SCI6.SMR.BIT.PE= 1;		//peBL
					SCI6.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI6_STOP_2
					SCI6.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI6_DATA_7
					SCI6.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI6.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI6.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI6.BRR= brr;			//{[[g(BRR)w

			SCI6.SCR.BIT.RE= 1;		//M
			//SCI6.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[232].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1D].BIT.IEN0= 1;	//荞RXI6[xN^232]
			//ICU.IER[0x1D].BIT.IEN1= 1;	//荞TXI6[xN^233]
			ICU.IER[0x1D].BIT.IEN2= 1;	//荞TEI6[xN^234]

			ICU.IR[232].BIT.IR= 0;
			ICU.IR[233].BIT.IR= 0;
			ICU.IR[234].BIT.IR= 0;

			SCI6.SCR.BIT.RIE= 1;		//M݋
			//SCI6.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN6= 1;		//O[v12(ERI6)荞݋
			break;

			// ----- SCI8 -----
		case 8:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRC.BIT.MSTPC27= 0;	//SCI8W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI8.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
			PORTC.PMR.BIT.B6= 0;			//PC6:ėpI/O
			PORTC.PODR.BIT.B7= 1;			//PC7:1o
			PORTC.PDR.BIT.B7= 1;			//PC7:-o
			PORTC.PMR.BIT.B7= 0;			//PC7:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.PC7PFS.BIT.PSEL= 0x0a;		//|[gPC7:TXD8
			MPC.PC6PFS.BIT.PSEL= 0x0a;		//|[gPC6:RXD8
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORTC.PMR.BIT.B6= 1;			//PC6:Ӌ@\ɐݒ
			//PORTC.PMR.BIT.B7= 1;			//PC7:Ӌ@\ɐݒ(ł͂Ȃ)

			SCI8.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI8.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI8_PARITY_EVEN
					SCI8.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI8_PARITY_ODD
					SCI8.SMR.BIT.PE= 1;		//peBL
					SCI8.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI8_STOP_2
					SCI8.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI8_DATA_7
					SCI8.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI8.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI8.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI8.BRR= brr;			//{[[g(BRR)w

			SCI8.SCR.BIT.RE= 1;		//M
			//SCI8.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[238].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1D].BIT.IEN6= 1;	//荞RXI8[xN^238]
			//ICU.IER[0x1D].BIT.IEN7= 1;	//荞TXI8[xN^239]
			ICU.IER[0x1E].BIT.IEN0= 1;	//荞TEI8[xN^240]

			ICU.IR[238].BIT.IR= 0;
			ICU.IR[239].BIT.IR= 0;
			ICU.IR[240].BIT.IR= 0;

			SCI8.SCR.BIT.RIE= 1;		//M݋
			//SCI8.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN8= 1;		//O[v12(ERI8)荞݋
			break;

			// ----- SCI12 -----
		case 12:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB4= 0;	//SCI12W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI12.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			// |[gݒ̕ύX
			PORTE.PODR.BIT.B1= 1;			//PE1:1o
			PORTE.PDR.BIT.B1= 1;			//PE1:-o
			PORTE.PMR.BIT.B1= 0;			//PE1:ėpI/O
			PORTE.PMR.BIT.B2= 0;			//PE2:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.PE1PFS.BIT.PSEL= 0x0c;		//|[gPE1:TXD12
			MPC.PE2PFS.BIT.PSEL= 0x0c;		//|[gPE2:RXD12
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			//PORTE.PMR.BIT.B1= 1;			//PE1:Ӌ@\ɐݒ(ł͂Ȃ)
			PORTE.PMR.BIT.B2= 1;			//PE2:Ӌ@\ɐݒ

			SCI12.SCR.BIT.CKE= 0;	//{[[gWFl[^iSCKo͂Ȃj
			SCI12.SMR.BYTE= 0;		//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI12_PARITY_EVEN
					SCI12.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI12_PARITY_ODD
					SCI12.SMR.BIT.PE= 1;		//peBL
					SCI12.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI12_STOP_2
					SCI12.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI12_DATA_7
					SCI12.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI12.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI12.SEMR.BYTE= 0x10;	//ABCS=1 (ABCS=0ȂvZ 48M/(32*(brr+1)) [bps])

			SCI12.BRR= brr;			//{[[g(BRR)w

			SCI12.SCR.BIT.RE= 1;		//M
			//SCI12.SCR.BIT.TE= 1;		//Mił͂Ȃj

			ICU.IPR[250].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1F].BIT.IEN2= 1;	//荞RXI12[xN^250]
			//ICU.IER[0x1F].BIT.IEN3= 1;	//荞TXI12[xN^251]
			ICU.IER[0x1F].BIT.IEN4= 1;	//荞TEI12[xN^252]

			ICU.IR[250].BIT.IR= 0;
			ICU.IR[251].BIT.IR= 0;
			ICU.IR[252].BIT.IR= 0;

			SCI12.SCR.BIT.RIE= 1;		//M݋
			//SCI12.SCR.BIT.TIE= 1;		//M݋ił͂Ȃj

			ICU.IPR[114].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x0E].BIT.IEN2= 1;	//荞GROUP12[xN^114] .IEN2͌Œ
			ICU.GEN[12].BIT.EN12= 1;	//O[v12(ERI12)荞݋
			break;
	}

	//I[vtÕZbg
	RXRS_openflag[ncom]= 1;
	return 0;
}

// Mobt@̃`FbN
// obt@̋󂫂oCgPʂŕԂ
// (Mobt@̃TCY傫ȒlԂƂ͂Ȃ)
int RXRS_CheckSend(int ncom)
{
	int rp,wp;
	if(!RXRS_openflag[ncom]) return 0;

	wp= RXRS_send_wptr[ncom];
	rp= RXRS_send_rptr[ncom];

	if (rp<0) return RXRS_sbuffersize[ncom];

	if (wp>rp){
		return RXRS_sbuffersize[ncom]-(wp-rp);
	}else{
		return (rp-wp);
	}
}

// Mobt@̃NA
// Sf[^̑M҂Ăobt@NA
int RXRS_ClearSend(int ncom)
{
	if(!RXRS_openflag[ncom]) return 1;

	while(rxrs_rx_status[ncom]);	//Sf[^M҂

	RXRS_send_rptr[ncom]= -1;
	return 0;
}

// f[^̑M (f[^͑Mobt@֊i[)
// Mobt@tɂȂ΁Cȍ~̃f[^͔j
// ߂lFMoCg
int RXRS_Send(int ncom, const char *buf, int n)
{
	int i,wp;
	if(!RXRS_openflag[ncom]) return 0;
	
	//f[^𑗐Mobt@֊i[
	for(i=0;i<n;i++){
		wp= RXRS_send_wptr[ncom];
		if (wp == RXRS_send_rptr[ncom]){	//buffer full
			if(i) break; else return i;	
		}

		RXRS_sbuffer[ncom][wp]= *buf++;

		if ((wp+1) == RXRS_sbuffersize[ncom]) RXRS_send_wptr[ncom]= 0;
		else RXRS_send_wptr[ncom]++;

		if (RXRS_send_rptr[ncom]<0) RXRS_send_rptr[ncom]= wp;
	}

	//TEI荞ݏ̂Ƃ͂ꂪI܂ő҂
	while(rxrs_rx_status[ncom]==2);

	if(!rxrs_rx_status[ncom]){
		rxrs_rx_status[ncom]= 1;
		//ŏRXǏĂяo
		switch(ncom){
			case 0:
				SCI0.SCR.BIT.TIE= 1;	//M荞݋
				SCI0.SCR.BIT.TE= 1;		//M
			#ifdef SCI0_RXDTXD_P33P32
				PORT3.PMR.BIT.B2= 1;	//P32:Ӌ@\ɐݒ
			#else
				PORT2.PMR.BIT.B0= 1;	//P20:Ӌ@\ɐݒ
			#endif
				ICU.IER[0x1A].BIT.IEN7= 1;	//荞TXI0[xN^215]
				break;

			case 1:
				SCI1.SCR.BIT.TIE= 1;	//M荞݋
				SCI1.SCR.BIT.TE= 1;		//M
				PORT2.PMR.BIT.B6= 1;	//P26:Ӌ@\ɐݒ
				ICU.IER[0x1B].BIT.IEN2= 1;	//荞TXI1[xN^218]
				break;

			case 2:
				SCI2.SCR.BIT.TIE= 1;	//M荞݋
				SCI2.SCR.BIT.TE= 1;		//M
			#ifdef SCI2_RXDTXD_P52P50
				PORT5.PMR.BIT.B0= 1;	//P50:Ӌ@\ɐݒ
			#else
				PORT1.PMR.BIT.B3= 1;	//P13:Ӌ@\ɐݒ
			#endif
				ICU.IER[0x1B].BIT.IEN5= 1;	//荞TXI2[xN^221]
				break;

			case 3:
				SCI3.SCR.BIT.TIE= 1;	//M荞݋
				SCI3.SCR.BIT.TE= 1;		//M
				PORT2.PMR.BIT.B3= 1;	//P23:Ӌ@\ɐݒ
				ICU.IER[0x1C].BIT.IEN0= 1;	//荞TXI3[xN^224]
				break;

			case 5:
				SCI5.SCR.BIT.TIE= 1;	//M荞݋
				SCI5.SCR.BIT.TE= 1;		//M
				PORTC.PMR.BIT.B3= 1;	//PC3:Ӌ@\ɐݒ
				ICU.IER[0x1C].BIT.IEN6= 1;	//荞TXI5[xN^230]
				break;

			case 6:
				SCI6.SCR.BIT.TIE= 1;	//M荞݋
				SCI6.SCR.BIT.TE= 1;		//M
				PORT3.PMR.BIT.B2= 1;	//P32:Ӌ@\ɐݒ
				ICU.IER[0x1D].BIT.IEN1= 1;	//荞TXI6[xN^233]
				break;

			case 8:
				SCI8.SCR.BIT.TIE= 1;	//M荞݋
				SCI8.SCR.BIT.TE= 1;		//M
				PORTC.PMR.BIT.B7= 1;	//PC7:Ӌ@\ɐݒ
				ICU.IER[0x1D].BIT.IEN7= 1;	//荞TXI8[xN^239]
				break;

			case 12:
				SCI12.SCR.BIT.TIE= 1;	//M荞݋
				SCI12.SCR.BIT.TE= 1;	//M
				PORTE.PMR.BIT.B1= 1;	//PE1:Ӌ@\ɐݒ
				ICU.IER[0x1F].BIT.IEN3= 1;	//荞TXI12[xN^251]
				break;
		}
	}
	return i;
}

//P̑M
//߂lFMoCg
int RXRS_Putc(int ncom, char c)
{
	if(!RXRS_openflag[ncom]) return 0;
	return RXRS_Send(ncom,&c,1);
}

//̑MiŌ\r\nj
//߂lFMoCg
int RXRS_Puts(int ncom, const char *s)
{
	int n;
	if(!RXRS_openflag[ncom]) return 0;

	n= strlen(s);
	n= RXRS_Send(ncom,s,n);
	n+=RXRS_Send(ncom,"\r\n",2);

	return n;
}

//̑MiŌɉȂj
//߂lFMoCg
int RXRS_Sends(int ncom, const char *s)
{
	int n;
	if(!RXRS_openflag[ncom]) return 0;

	n= strlen(s);
	n= RXRS_Send(ncom,s,n);

	return n;
}

//t񑗐M
//߂lFMoCg
#include <stdio.h>
#include <stdarg.h>
#ifndef RXRS_PRINTF_BUFFERSIZE
	#define RXRS_PRINTF_BUFFERSIZE	256
#endif
int RXRS_Printf(int ncom, const char *format, ...)
{
	va_list vl;
	char buf[RXRS_PRINTF_BUFFERSIZE];

	va_start(vl,format);
	vsprintf(buf,format,vl);

	return RXRS_Sends(ncom,buf);
}

// f[^̎M (Mobt@̓ǂݏo)
int RXRS_Recv(int ncom, char *buf, int n)
{
	int i,rp;
	
	if(!RXRS_openflag[ncom]) return 0;

	if(n>RXRS_rbuffersize[ncom]) n=RXRS_rbuffersize[ncom];
	
	for(i=0;i<n;i++){
		rp=RXRS_recv_rptr[ncom];
		if (rp<0) break;

		*buf++ = RXRS_rbuffer[ncom][rp++];

		if(rp==RXRS_rbuffersize[ncom]) rp=0;
		if(rp==RXRS_recv_wptr[ncom]) rp=-1;
		RXRS_recv_rptr[ncom]=rp;
	}
	return i;
}

// Mobt@̃`FbN
// (obt@Ɋi[ς݂̃f[^oCgPʂŕԂ)
int RXRS_CheckRecv(int ncom)
{
	int rp,wp;
	
	if(!RXRS_openflag[ncom]) return 0;

	rp=RXRS_recv_rptr[ncom];
	wp=RXRS_recv_wptr[ncom];

	if (rp<0) return 0;

	if (wp>rp){
		return wp-rp;
	}else{
		return RXRS_rbuffersize[ncom]-(rp-wp);
	}
}

// Mobt@̃NA
int RXRS_ClearRecv(int ncom)
{
	if(!RXRS_openflag[ncom]) return 1;
	RXRS_recv_rptr[ncom]= -1;
	return 0;
}

// P̎M
int RXRS_Getc(int ncom)
{
	char c;
	if(!RXRS_openflag[ncom]) return -1;
	if (!RXRS_Recv(ncom,&c,1)) return -1;
	return c;
}

// (Ōオ\n/\r/0̂ꂩ)̎M
int RXRS_Gets(int ncom, char *s)
{
	int n=0;
	if(!RXRS_openflag[ncom]) return n;

	for(;;){
		if (RXRS_Recv(ncom,s,1)==1) {
			if(*s=='\n' || *s=='\r' || *s==0){
				*s=0;
				n++;
				break;
			}else{
				s++;
				n++;
			}
		}
	}
	return n;
}

#ifdef __cplusplus
}
#endif

#endif
